/*  XRoar - a Dragon/Tandy Coco emulator
 *  Copyright (C) 2003-2005  Ciaran Anscomb
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

/* This GTK code is probably all wrong, but it does seem to work */

#include "config.h"

#ifdef HAVE_GTK_UI

#include "types.h"
#include "logging.h"

#include <stdlib.h>
#include <string.h>
#include <gtk/gtk.h>

#include "events.h"
#include "fs.h"
#include "ui.h"
#include "xroar.h"

static int init(void);
static void shutdown(void);
static void mainloop(void);
static void menu(void);
static char *load_filename(char **extensions);
static char *save_filename(char **extensions);

UIModule ui_gtk_module = {
	NULL,
	"gtk",
	"GTK+ user-interface",
	init, shutdown, mainloop,
	menu, load_filename, save_filename
};

static char *filename = NULL;

static int init(void) {
	LOG_DEBUG(2, "Initialising GTK+ user-interface\n");
	gtk_init(NULL, NULL);
	return 0;
}

static void shutdown(void) {
	LOG_DEBUG(2, "Shutting down GTK+ user-interface\n");
}

/* The GTK+ UI wants to take control of the application, so it sets the
 * main emulator loop up as something to do when GTK+ is idle. */
static gboolean idle_loop(gpointer data) {
	while (EVENT_PENDING)
		DISPATCH_NEXT_EVENT;
	m6809_cycle(event_list->at_cycle);
	return TRUE;
}

static void mainloop(void) {
	g_idle_add(idle_loop, NULL);
	gtk_main();
}

static void menu(void) {
}

static char *load_filename(char **extensions) {
	GtkWidget *dialog;
	if (filename)
		free(filename);
	filename = NULL;
	dialog = gtk_file_chooser_dialog_new ("Open File",
			NULL,
			GTK_FILE_CHOOSER_ACTION_OPEN,
			GTK_STOCK_CANCEL, GTK_RESPONSE_CANCEL,
			GTK_STOCK_OPEN, GTK_RESPONSE_ACCEPT,
			NULL);
	if (gtk_dialog_run(GTK_DIALOG(dialog)) == GTK_RESPONSE_ACCEPT) {
		char *fn = gtk_file_chooser_get_filename(GTK_FILE_CHOOSER(dialog));
		if (fn) {
			filename = (char *)malloc(strlen(fn)+1);
			strcpy(filename, fn);
			g_free(fn);
		}
	}
	gtk_widget_destroy(dialog);
	return filename;
}

static char *save_filename(char **extensions) {
	return load_filename(extensions);
}

#endif  /* HAVE_GTK_UI */
